<template>
  <div class="NoiseTemplateWrapper TemplateWrapper">
    <div class="groupTitle"><i
        class="el-icon-back"
        @click="back"
      ></i> {{txt}}</div>
    <PubTemplateGroup
      :editData="editData"
      @changeVal="changeVal"
      @validatePass="validatePass"
      ref="submitForm"
    ></PubTemplateGroup>
    <div class="main">
      <CommonTemplate
        v-if="dataPub.region1"
        :pool="dataPub.tagPool"
        :type="dataPub.region1"
        :options="editData"
         @changeActionData="changeActionData"
      >
      </CommonTemplate>
      <div class="btn">
        <el-button
          type="primary"
          @click="submitForm"
        >确 定</el-button>
      </div>
    </div>
  </div>
</template>
<script>
/**
 * dataPub.region2  判断底部显示哪些
 */
import PubTemplateGroup from './PubTemplateGroup';
import CommonTemplate from './CommonTemplate';
import api from '@api/icss.js';
import utils from '@api/utils.js';

export default {
  name: 'TemplateMaintenanceWrap',
  data() {
    return {
      txt:'模板维护--添加模板',
      dataPub: {},                    //公用组件传的值都在这
      editData:{},                    //编辑数据
      sendIds: [[], [], [], [], [], []],           //标签明细右侧操作数据
    }
  },
  beforeMount:function(){
    const {isEdit,data} = this.$route.params;
    if(isEdit){
      this.txt = '模板维护--修改模板';
      this.editData = data;
      // console.log('回读数据', this.editData)
    }
  },
  methods: {
    back() { this.$router.go(-1) },
    changeVal(val) {    //子组件数据改变传递到父组件
      this.dataPub = val    // console.log('公用组件传的值都在这', val)
    },
    changeActionData(arr) {          //标签明细右侧数据id
      this.sendIds = arr
    },
    submitForm() {       // 调用子组件的方法验证公用部分
      this.$refs.submitForm.submitForm('groups');
    },
    validatePass() {      //验证成功回调，调取接口
      //仍需验证标签明细是否选择
      let type = this.dataPub.region1,name=this.dataPub.region2;
      if (JSON.stringify(this.sendIds) == '[]') {
        this.$message({
          message: '请选择标签明细',
          type: 'warning'
        });
        return;
      }
      let detailLis = utils.orderTemplateData(this.sendIds)
      let param = {
        "modelDetils": detailLis,
        "name": name,
        "type": type,
        "id":this.editData.id || ''
      }
      console.log(param,'保存模板的参数')
      this.showDelDialog(param)
    },
    showDelDialog(param) {
      this.showConfirmDialog('是否保存该模板？', () => {
        if(this.editData.id){
          api.updateModuleInfo(param).then((res) => {
            if (res.data.code === '0') {
              this.warning(res.data.msg || '修改成功', 'success','1000')
              setTimeout(() => {
                this.$router.push({
                  path:'/admin/LT-YXSJWH-MBWH'
                })
              }, 1000);
            } else {
              this.warning(res.data.msg)
            }
          }).catch((err) => {
            this.warning(err);
          })
        }else{
          api.saveModuleInfo(param).then((res) => {
          if (res.data.code === '0') {
            this.warning(res.data.msg || '保存成功', 'success','1000')
            setTimeout(() => {
              this.$router.push({
                path:'/admin/LT-YXSJWH-MBWH'
              })
            }, 1000);
          } else {
            this.warning(res.data.msg)
          }
        }).catch((err) => {
          this.warning(err);
        })
        }
        
      });
    },
    showConfirmDialog(msg, resolve) {
      this.$alert(msg, '提示', {
        confirmButtonText: '确定',
        type: 'warning'
      }).then(() => {
        resolve();
      }).catch(() => {});
    },
    warning(msg, type,time) {
      this.$message({
        showClose: true,
        message: msg,
        type: type || 'warning',
        duration:time || '3000'
      })
    },
  },
  components: {
    PubTemplateGroup,
    CommonTemplate,
  }
}
</script>
<style lang="less">
@import "../../less/common.less";
.NoiseTemplateWrapper {
  .groupTitle {
    background-color: #fff;
    height: 40px;
    line-height: 40px;
    padding-left: 20px;
  }
  .main {
    background-color: #fff;
    margin: 0 20px 20px;
    padding: 20px;
    border-top: 1px solid @icssBorder;
    box-sizing: border-box;
    font-size: 14px;
    color: #606266;
    .title {
      margin-bottom: 20px;
      i {
        color: #f56c6c;
      }
    }
  }
  .btn {
    text-align: right;
  }
  .order {
    margin-bottom: 20px;
    .el-input__inner {
      line-height: 30px;
      height: 30px;
    }
  }
}
</style>

